require "routinized/version"
require 'fileutils'
require 'json'
Dir[File.dirname(__FILE__) + '/commands/*.rb'].each {|file| require file }
module Routinized
  ROOT = File.join(Dir.home,'.routinized')

  def self.config
    JSON.load(File.open(File.join(ROOT, 'config.json')))
  end

  def self.upgrade
    _distribute_files('wrappers') + _distribute_files('commands')
  end

  def self.bootstrap
    Dir.mkdir(ROOT,0755) unless File.exists?(ROOT)
    Routinized.upgrade
    ['master.rb.template','config.json.template'].each do |file|
      dest_file = file.split(".template").first
      FileUtils.cp File.join(File.dirname(__FILE__) + "/templates/#{file}"), File.join(ROOT,dest_file)
    end
  end

  def self.command(name,args)
    Routinized::Commands.send(name.to_sym,args)
  end

  private

  def self._distribute_files(directory)
    Dir.chdir(ROOT)
    Dir.mkdir(directory) unless File.exists?(directory)
    FileUtils.cp_r Dir.glob(File.dirname(__FILE__) + "/#{directory}/*.rb"), File.join(ROOT,directory), :remove_destination => true
    return Dir.entries(File.join(ROOT,directory)).select{|f| f =~ /rb/}.map{|x| x.split(".rb").first}
  end
end
